import random
import threading
import thread
from socket import *
from XmlMessage import XmlMessage
from time import sleep
from string import capitalize
from defines import *


class Receiver(threading.Thread):

	def __init__(self,Node):
		self.node = Node
		self.sck = socket(AF_INET,SOCK_DGRAM,0)
		try:
			self.sck.bind(('',int(self.node.port)))
		except:
			debug("ERROR - Kill last process starting on port %s()"%self.node.port)
		self.BUFSIZ = 1024
		threading.Thread.__init__(self)


	def run(self):
		while 1:
			msg_raw,addr = self.sck.recvfrom(self.BUFSIZ)
			msg = XmlMessage(msg_raw)
			type = msg.getType()

			exec("thread.start_new_thread(self.receive%s, (msg,))"%capitalize(type))
	
	def receiveReq(self,msg):
		debug("******** received request from %d"%msg.getSender())
		sender = msg.getSender()
		seq    = msg.getSeqNumber()
		body   = msg.getBody()
		
		# THIS FUNCTION IS YET COMPLETELY BROKEN
		# AND WITH LOCKING PROBLEMS

		self.node.state_lock.acquire()
		self.node.seq_lock.acquire()
		hi = self.node.hiseq
		self.node.hiseq = max(hi,seq)
		myseq = self.node.seq
		debug("req - his_seq %d, my_seq %d, hiseq %d"%(seq, myseq, hi))
		our_prio = 	(myseq > seq) or\
					((myseq == seq) and (self.node.myno > (sender + 1)))
		self.node.seq_lock.release()

		
		may_defer = (self.node.state == USING) or\
					(self.node.state == WAITING and our_prio)
			
		debug("req - state %d, our_prio %d, may_defer %d"%(self.node.state, our_prio, may_defer))

		
			
		if may_defer:
			self.node.auth_lock.acquire()
			self.node.deferred_auth[sender-1] = 1
			self.node.auth_lock.notifyAll()
			self.node.auth_lock.release()
		
		self.node.auth_lock.acquire()
		auth = self.node.auth[sender-1]
		self.node.auth_lock.notifyAll()
		self.node.auth_lock.release()
		
		if (self.node.state <> USING and self.node.state <> WAITING) or\
			(self.node.state == WAITING and (not auth) and (not our_prio)):
			self.node.auth_lock.acquire()
			self.node.auth[sender - 1] = 0
			self.node.auth_lock.notifyAll()
			self.node.auth_lock.release()
			self.node.sender.send_reply(sender)
		elif ((self.node.state == WAITING) and (auth) and (not our_prio)):
			self.node.auth_lock.acquire()
			self.node.auth[sender - 1] = 0
			self.node.auth_lock.notifyAll()
			self.node.auth_lock.release()
			self.node.sender.send_reply(sender)
			self.node.sender.send_request(sender)
		

		debug("req - authorizations : %s"%self.node.auth)
		debug("req - deferred_authorizations :%s"%self.node.deferred_auth)
		self.node.state_lock.release()
		

	
	def receiveRep(self,msg):
		debug("******** received response from %d"%msg.getSender())
		sender = msg.getSender()
		seq    = msg.getSeqNumber()
		body   = msg.getBody()
	
		#debug("rep - his_seq %d, my_seq %d, hiseq %d"%(seq, self.node.seq, self.node.hiseq))
	
		self.node.auth_lock.acquire()
		self.node.auth[sender - 1] = 1
		self.node.auth_lock.notifyAll()
		self.node.auth_lock.release()
		
		debug("rep - authorizations : %s"%self.node.auth)
		debug("rep - deferred_authorizations :%s"%self.node.deferred_auth)
