from sys import stderr

DEBUG = 1

# possible states
FREE = 0
WAITING = 1
USING = 2

class Application:
	def __init__(self):
		pass
	
	def InputMsg(self, info):
		glob,msg = info
		print "*** App receives message %s from %s (Global %s)"%\
				( msg.getSiteNumber(),msg.getSender(),glob)
				
def debug(str):
	if DEBUG:
		print >> stderr, str


class Sequence:
	def __init__(self,node):
		self.seqno = 0
		self.node = node
	
	def __gt__(self,x):
		if self.seqno > x.seqno:
			return True
		elif (self.seqno == x.seqno) and self.node > x.node:
			return True
		return False

	def __add__(self,x):
		return Sequence(self.seqno + x,self.node)

	def __repr__(self):
		return "(#%d,%d)"%(self.seqno,self.node)
