import random
import threading
from socket import *
from XmlMessage import XmlMessage
from time import sleep
from defines import *

class Sender:
	
	def __init__(self, Node):
		self.node = Node
		
	def send_request(self,node):
		debug("******** send request to %d"%node)
		# Send a request message with sequence seq to node 
		me = self.node.myno
		seq = self.node.seq
		body = 1
		
		msg = XmlMessage()
		msg.setData_req(me, seq, body)
		
		ip = self.node.ip_list[node-1]
		
		self.node.transmitter.sendMsg(msg, ip)
	
	def send_reply(self,node):
		debug("******** send reply to %d"%node)
		# positively reply to node
		me = self.node.myno
		seq = self.node.seq
		body = 2
		
		msg = XmlMessage()
		msg.setData_rep(me, seq, body)
		
		ip = self.node.ip_list[node-1]
		
		self.node.transmitter.sendMsg(msg, ip)